﻿using System.Collections.ObjectModel;
using System.ComponentModel;

namespace IGDocumentation
{
    public class DataObjectLevel4 : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public string Data1 { get; set; }

        public string Data2 { get; set; }

        public string Data3 { get; set; }

        public DataObjectLevel4()
        {
            Data1 = "4th level data 1.";
            Data2 = "4th level data 2.";
            Data3 = "4th level data 3.";
        }
    }

    public class DataObjectLevel3 : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public int ProjNum { get; set; }
        public string ProjName { get; set; }
        public string Task { get; set; }
        public string CostType { get; set; }
        public string CostTypeName { get; set; }
        public int Bud_ITD_Rev { get; set; }
        public int RemainingBudget { get; set; }
        public int Revenue { get; set; }
        public int Sub_Goal_Amt { get; set; }
        public int PTD_Goal_Amt { get; set; }
        public int ITD_Goal_Amt { get; set; }
        public int Sub_Dir_Amt { get; set; }
        public int PTD_Dir_Amt { get; set; }
        public int ITD_Dir_Amt { get; set; }

        //public ObservableCollection<DataObjectLevel4> Children { get; set; }

        public DataObjectLevel3()
        {
            ProjNum = 0123456;
            ProjName = "Project Name";
            Task = "Task";
            CostType = "Type A";
            CostTypeName = "Type A";
            Bud_ITD_Rev = 0123456;
            RemainingBudget = 0123456;
            Revenue = 0123456;
            Sub_Goal_Amt = 0123456;
            PTD_Goal_Amt = 0123456;
            ITD_Goal_Amt = 0123456;
            Sub_Dir_Amt = 0123456;
            PTD_Dir_Amt = 0123456;
            ITD_Dir_Amt = 0123456;

            /*Children = new ObservableCollection<DataObjectLevel4>();
            Children.Add(new DataObjectLevel4());
            Children.Add(new DataObjectLevel4());
            Children.Add(new DataObjectLevel4());*/
        }
    }

    public class DataObjectLevel2 : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public int ProjNum { get; set; }

        public string Task { get; set; }

        public string ProjName { get; set; }
        public int Bud_ITD_Rev { get; set; }
        public int RemainingBudget { get; set; }
        public int TGT_ITD_Rev { get; set; }
        public int RemainingRevenue { get; set; }
        public int Sub_Goal_Amt { get; set; }
        public int PTD_Goal_Amt { get; set; }
        public int ITD_Goal_Amt { get; set; }
        public int Sub_Dir_Amt { get; set; }
        public int PTD_Dir_Amt { get; set; }
        public int ITD_Dir_Amt { get; set; }
        public int AllowCharges { get; set; }
        public int Billed_Amt { get; set; }
        public int Bal_Due_Amt { get; set; }
        public int WIP { get; set; }
        public int AROver90 { get; set; }
        public string DivName { get; set; }
        public string PCName { get; set; }
        public int OrgID { get; set; }
        public string Cust_Name { get; set; }
        public string ProjectManagerName { get; set; }

        public ObservableCollection<DataObjectLevel3> CostInfo { get; set; }

        public DataObjectLevel2()
        {
            ProjNum = 0123456;
            Task = "0001";
            ProjName = "Project Name";
            Bud_ITD_Rev = 0123456;
            RemainingBudget = 0123456;
            TGT_ITD_Rev = 0123456;


            RemainingRevenue = 0123456;
            Sub_Goal_Amt = 0123456;
            PTD_Goal_Amt = 0123456;
            ITD_Goal_Amt = 0123456;
            Sub_Dir_Amt = 0123456;
            PTD_Dir_Amt = 0123456;
            ITD_Dir_Amt = 0123456;
            AllowCharges = 0123456;
            Billed_Amt = 0123456;
            Bal_Due_Amt = 0123456;
            WIP = 0123456;
            AROver90 = 0123456;

            DivName = "Division Name";
            PCName = "PC Name";
            OrgID = 012;
            Cust_Name = "Customer Name";
            ProjectManagerName = "Project Manager Name";
            CostInfo = new ObservableCollection<DataObjectLevel3>();
            CostInfo.Add(new DataObjectLevel3());
            CostInfo.Add(new DataObjectLevel3());
        }
    }

    public class DataObjectLevel1 : INotifyPropertyChanged
    {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public string Alerts_Flag { get; set; }
        public bool CP_Flag { get; set; }
        public string Company { get; set; }
        public int ProjNum { get; set; }
        public string ProjName { get; set; }
        public int Bud_ITD_Rev { get; set; }
        public int RemainingBudget { get; set; }
        public int TGT_ITD_Rev { get; set; }
        public int RemainingRevenue { get; set; }
        public int Sub_Goal_Amt { get; set; }
        public int PTD_Goal_Amt { get; set; }
        public int ITD_Goal_Amt { get; set; }
        public int Sub_Dir_Amt { get; set; }
        public int PTD_Dir_Amt { get; set; }
        public int ITD_Dir_Amt { get; set; }
        public int AllowCharges { get; set; }
        public int Billed_Amt { get; set; }
        public int Bal_Due_Amt { get; set; }
        public int WIP { get; set; }
        public string AROver90 { get; set; }
        public string DivName { get; set; }
        public string PCName { get; set; }
        public int OrgID { get; set; }
        public string Cust_Name { get; set; }
        public string ProjectManagerName { get; set; }

        public ObservableCollection<DataObjectLevel2> TaskInfo { get; set; }

        public DataObjectLevel1()
        {
            Alerts_Flag = "1st level data 1.";
            CP_Flag = true;
            Company = "Company Name";
            ProjNum = 0123456;
            ProjName = "Project Name";
            Bud_ITD_Rev = 0123456;
            RemainingBudget = 0123456;
            TGT_ITD_Rev = 0123456;

            RemainingRevenue = 0123456;
            Sub_Goal_Amt = 0123456;
            PTD_Goal_Amt = 0123456;
            ITD_Goal_Amt = 0123456;
            Sub_Dir_Amt = 0123456;
            PTD_Dir_Amt = 0123456;
            ITD_Dir_Amt = 0123456;
            AllowCharges = 0123456;
            Billed_Amt = 0123456;
            Bal_Due_Amt = 0123456;
            WIP = 0123456;
            AROver90 = "Some Text";

            DivName = "Division Name";
            PCName = "PC Name";
            OrgID = 012;
            Cust_Name = "Customer Name";
            ProjectManagerName = "Project Manager Name";

            TaskInfo = new ObservableCollection<DataObjectLevel2>();
            TaskInfo.Add(new DataObjectLevel2());
            TaskInfo.Add(new DataObjectLevel2());
        }
    }

    public class DataObjectCollection : ObservableCollection<DataObjectLevel1>
    {
        public DataObjectCollection(int count)
        {
            for (int i = 0; i < count; i++)
                this.Add(new DataObjectLevel1());
        }
    }

}